<'
package shr_spi3;

sequence shr_spi3_arb_xtpa_sequence_s using
   item = shr_spi3_xtpa_s,
   created_driver = shr_spi3_arb_xtpa_driver_u;

extend shr_spi3_arb_xtpa_driver_u {
   agent : LINK shr_spi3_arbiter_u;
   event clock is only @agent.clock;
};

extend LINK shr_spi3_arbiter_u {
   xtpa_driver : shr_spi3_arb_xtpa_driver_u is instance;
   keep xtpa_driver.agent == me;
};

///////////////////////////////////////////////////
//The following sequence controls the order in which
//ports are "checked" for valid data in the outgoing direction
//This is no guarantee that the port actually has data available,
//but is only the order in which the port is attempted.
//////////////////////////////////////////////////
sequence shr_spi3_arbiter_sequence_s using 
    item = shr_spi3_arb_result_s,
    created_driver = shr_spi3_arb_driver_u,
    created_kind = shr_spi3_arb_sequence_kind_t;


extend shr_spi3_arb_driver_u {
    agent : shr_spi3_agent_u;
    arb   : shr_spi3_arbiter_u;

    event clock is only @agent.clock;            // Clock event is obtained from the agent's clock source
};


extend shr_spi3_arbiter_u {
    driver : shr_spi3_arb_driver_u is instance;
        keep driver.agent == agent;
	keep driver.arb == me;
};


extend MAIN shr_spi3_arbiter_sequence_s {
    keep soft count == MAX_UINT;
//    keep soft item == driver.agent.get_next_port();
};

extend shr_spi3_arb_sequence_kind_t : [RR];

extend RR shr_spi3_arbiter_sequence_s {
   
   !arb_result : shr_spi3_arb_result_s;
   
   body()@driver.clock is only {
   
      var next_port_index : uint;  //Next INDEX into the active ports list to try
   
      if driver.arb.active_port_index == (driver.arb.numports - 1) then {
      	 next_port_index = 0;
      } else {
      	 next_port_index = driver.arb.active_port_index + 1;
      };
      
      driver.arb.active_port_index = next_port_index;
      
      do arb_result keeping {
      	 it.port_found == TRUE;
	 it.port_id == driver.agent.config.active_ports[next_port_index];
      };
   
   };
};//extend RR shr_spi3_arbiter_sequence_s
      
'>
