<'
package shr_spi3;

extend shr_spi3_bfm_data_sequence_kind : [SIMPLE_PARITY_ERROR];

extend SIMPLE_PARITY_ERROR shr_spi3_bfm_data_sequence {

//This sequence will generate a random transfer and mark it as haveing
//bad parity.


   !datacycle  : OUT LAYERED shr_spi3_datacycle_s;
   
   body()@driver.clock is only {
      do datacycle keeping {
      
      	 it.xfer_start == 0;     
      	 it.enable == 0;  //This transfer should be 'enabled'
	 it.valid == 1;   //It should also be valid
	 it.bad_parity == TRUE;
      };//do datacycle
   };//body()@driver.clock

};//extend SIMPLE_PARITY_ERROR shr_spi3_bfm_data_sequence

extend shr_spi3_bfm_data_sequence_kind : [PARITY_ERROR];

extend PARITY_ERROR shr_spi3_bfm_data_sequence {

   !layered_payload : LAYERED_PAYLOAD shr_spi3_bfm_data_sequence;
      
   body() @driver.clock is only {
   
      do layered_payload keeping {
      	 it.has_parity_error == TRUE;
      };
   
   };//body() @driver.clock

};//extend PARITY_ERROR shr_spi3_bfm_data_sequence

extend shr_spi3_bfm_data_sequence_kind : [XERR_ERROR];

extend XERR_ERROR shr_spi3_bfm_data_sequence {

   !layered_payload : LAYERED_PAYLOAD shr_spi3_bfm_data_sequence;
      
   body() @driver.clock is only {
   
      do layered_payload keeping {
      	 it.has_xERR == TRUE;
      };
   
   };//body() @driver.clock

};//extend XERR_ERROR shr_spi3_bfm_data_sequence

extend shr_spi3_bfm_data_sequence_kind : [SOP_SOP_ERROR];


extend SOP_SOP_ERROR shr_spi3_bfm_data_sequence {
   !layered_payload_sequence : LAYERED_PAYLOAD shr_spi3_bfm_data_sequence;
   !datacycle : OUT LAYERED shr_spi3_datacycle_s;
   
   cycles_until_error : uint;
   keep soft cycles_until_error in [1..5];
   
   valid_sop_sent : bool;
   keep valid_sop_sent == FALSE;
   
   body() @ driver.clock is only {
      do layered_payload_sequence;
      
      var cycles_since_sop : uint;
      
      repeat {
      
      	 if (driver.last(0).enable == 0 and driver.last(0).sop == 1)  then {
	    valid_sop_sent = TRUE;
	 };
      	 
	 if cycles_since_sop == cycles_until_error then {
	    do datacycle keeping {
	       it.xfer_start == 0;
	       it.enable == 0;
	       it.sop == 1;
	    };
	 } else {
	    do layered_payload_sequence;
	    cycles_since_sop = cycles_since_sop + 1;
	 };	 
	    
      } until (driver.last(0).enable ==0 and driver.last(0).eop == 1);
   };//body()@driver.clock
};//extend SOP_SOP_ERROR

extend shr_spi3_bfm_data_sequence_kind : [EOP_MOP_EOP_ERROR];

extend EOP_MOP_EOP_ERROR shr_spi3_bfm_data_sequence {

   !layered_payload : LAYERED_PAYLOAD shr_spi3_bfm_data_sequence;

   body() @driver.clock is only {
   
      do layered_payload;
      
      repeat {
      	 if (driver.last(0).sop == 1) then {
	    driver.lose_next_sop = TRUE;
	    driver.lose_next_sop_port = driver.bfm.active_port;
	 }; 
	 
	 do layered_payload;
      } until (driver.lose_next_sop == TRUE);
   
   };//body() @driver.clock

};//extend EOP_MOP_EOP_ERROR shr_spi3_bfm_data_sequence

extend shr_spi3_bfm_data_sequence_kind : [SOP_MOP_SOP_ERROR];

extend SOP_MOP_SOP_ERROR shr_spi3_bfm_data_sequence {

   !layered_payload : LAYERED_PAYLOAD shr_spi3_bfm_data_sequence;

   body() @driver.clock is only {
   
      do layered_payload;
      
      repeat {
      	 if (driver.last(0).sop == 1) then {
	    driver.lose_next_eop = TRUE;
	    driver.lose_next_eop_port = driver.bfm.active_port;
	 }; 
	 
	 do layered_payload;
      } until (driver.lose_next_eop == TRUE);
   
   };//body() @driver.clock

};//extend EOP_MOP_EOP_ERROR shr_spi3_bfm_data_sequence

extend shr_spi3_bfm_data_sequence_kind : [RND_PAUSE];


extend shr_spi3_bfm_data_sequence_kind : [xSX_PARITY_ERROR];

extend xSX_PARITY_ERROR shr_spi3_bfm_data_sequence {

   !layered_payload : LAYERED_PAYLOAD shr_spi3_bfm_data_sequence;
   
   body() @driver.clock is only {
   
      do layered_payload;
      
      driver.corrupt_next_xSX = TRUE;
   
   };//body

};// extend xSX_PARITY_ERROR shr_spi3_bfm_data_sequence

extend RND_PAUSE shr_spi3_bfm_data_sequence {
   
   !layered_payload : LAYERED_PAYLOAD shr_spi3_bfm_data_sequence;
   !datacycle : OUT LAYERED shr_spi3_datacycle_s;
   
   prev_cycle_valid_data : bool;
   keep prev_cycle_valid_data == FALSE;
   
   body() @driver.clock is only {
      do layered_payload;
      
      var pause_now : bool;
      pause_now = FALSE;
      
      repeat {
      	 if (driver.last(0).enable == 0) then {//last cycle was a valid cycle
	    gen pause_now keeping { 
	       soft it == select {
	          80 : FALSE;
		  20 : TRUE;
	       };
	    };
	    if pause_now == FALSE then {
	       do layered_payload;
	    } else {
	       do datacycle keeping {
	          it.enable == 1;
	       };
	    };
	 } else {
	    do layered_payload;
	 };
      } until (pause_now == TRUE );
   };//body() @driver.clock
	 
};//extend RND_PAUSE shr_spi3_bfm_data_sequence


extend shr_spi3_bfm_data_sequence_kind : [RANDOM_RX_LINK];

extend RANDOM_RX_LINK shr_spi3_bfm_data_sequence {
   !datacycle : shr_spi3_datacycle_s ;
   body() @driver.clock is only {
      do datacycle keeping {
      	 it.enable in [0..1];
	 it.valid_clocks in [5..20];
      };
   };  
};
   

extend shr_spi3_bfm_data_sequence_kind : [DEFAULT_TX_PHY];

extend DEFAULT_TX_PHY shr_spi3_bfm_data_sequence {
   !datacycle : shr_spi3_datacycle_s;
   
   body() @driver.clock is only {
      do datacycle keeping {
      	 it.dtpa == 0xffff;
	 it.stpa == 1;
	 it.ptpa == 1;
	 it.valid_clocks in [5..20];
      };
   };//body
};//extend DEFAULT_TX_PHY shr_spi3_bfm_data_sequence

extend shr_spi3_bfm_data_sequence_kind : [D70_80_CYCLE_INTER_PKT_GAP];


extend D70_80_CYCLE_INTER_PKT_GAP shr_spi3_bfm_data_sequence {
   !layered_payload_sequence : LAYERED_PAYLOAD shr_spi3_bfm_data_sequence;
   !datacycle : OUT LAYERED shr_spi3_datacycle_s;
   
   valid_eop_sent : bool;
   keep valid_eop_sent == FALSE;
   
   num_idle_cycles : uint;
   keep soft num_idle_cycles in [70..80];
   
   body() @ driver.clock is only {
      do layered_payload_sequence;
      
      repeat {
      
      	 if (driver.last(0).enable == 0 and driver.last(0).eop == 1)  then {
	    valid_eop_sent = TRUE;
	    gen num_idle_cycles;
	    
	    for i from 0 to num_idle_cycles-1 {
	       do datacycle keeping {
	          it.enable == 1;
		  it.valid == 0;
		  it.xfer_start == 0;
	       };
	    };
	 } else {
	    do layered_payload_sequence;
	 };
      	 	    
      } until (valid_eop_sent == TRUE);
   };//body()@driver.clock
};//extend SOP_SOP_ERROR

'>
