<'
package shr_spi3;

extend TX'direction shr_spi3_agent_u {
    sig_tsx   : inout simple_port of bit is instance;
    sig_tenb  : inout simple_port of bit is instance;
    sig_tsop  : inout simple_port of bit is instance;
    sig_teop  : inout simple_port of bit is instance;
    sig_terr  : inout simple_port of bit is instance;
    sig_tprty : inout simple_port of bit is instance;

    sig_tdat  : inout simple_port of uint is instance;
    keep sig_tdat.declared_range() == "[31:0]";
   
    sig_tmod  : inout simple_port of uint(bits:2) is instance;
    keep sig_tmod.declared_range() == "[1:0]";
   
    sig_tadr  : inout simple_port of uint is instance;
    sig_stpa  : inout simple_port of bit is instance;
    sig_ptpa  : inout simple_port of bit is instance;
    sig_dtpa  : inout simple_port of uint is instance;
    sig_tclk  : in simple_port of bit is instance;
    sig_tf_rst_l  : in simple_port of bit is instance;
   
    
    event clock is only rise(sig_tclk$)@sim;
    event reset_end is only rise(sig_tf_rst_l$)@sim;
};

extend RX'direction shr_spi3_agent_u {
    sig_rsx   : inout simple_port of bit is instance;
    sig_rval  : inout simple_port of bit is instance;
    sig_renb  : inout simple_port of bit is instance;
    sig_rsop  : inout simple_port of bit is instance;
    sig_reop  : inout simple_port of bit is instance;
    sig_rerr  : inout simple_port of bit is instance;
    sig_rprty : inout simple_port of bit is instance;

    sig_rdat  : inout simple_port of uint(bits:SHR_SPI3_MAX_BUS_WIDTH) is instance;
    keep soft sig_rdat.declared_range() == "[31:0]";

    sig_rmod  : inout simple_port of uint(bits:2) is instance;
    keep soft sig_rmod.declared_range() == "[1:0]";    

    sig_rclk  : in simple_port of bit is instance;
    sig_rf_rst_l  : in simple_port of bit is instance;
    
    event clock is only rise(sig_rclk$)@sim;
    event reset_end is only rise(sig_rf_rst_l$)@sim;   

};   

'>
extend LINK'layer RX'direction shr_spi3_agent_u {
    sig_rsx   : in simple_port of bit is instance;
    sig_rval  : in simple_port of bit is instance;
    sig_renb  : inout simple_port of bit is instance;
    sig_rsop  : in simple_port of bit is instance;
    sig_reop  : in simple_port of bit is instance;
    sig_rerr  : in simple_port of bit is instance;
    sig_rprty : in simple_port of bit is instance;
    sig_rdat  : in simple_port of uint is instance;
    keep soft sig_rdat.declared_range() == "[31:0]";
    sig_rmod  : in simple_port of uint(bits:2) is instance;
    keep soft sig_rmod.declared_range() == "[1:0]";
    sig_rclk  : in simple_port of bit is instance;
    sig_rf_rst_l  : in simple_port of bit is instance;
    
    event clock is only rise(sig_rclk$);
    event reset_end is only rise(sig_rf_rst_l$);   
};
extend PHY'layer TX'direction shr_spi3_agent_u {
    sig_tsx   : in simple_port of bit is instance;
    sig_tenb  : in simple_port of bit is instance;
    sig_tsop  : in simple_port of bit is instance;
    sig_teop  : in simple_port of bit is instance;
    sig_terr  : in simple_port of bit is instance;
    sig_tprty : in simple_port of bit is instance;
    sig_tdat  : in simple_port of uint(bits:SHR_SPI3_MAX_BUS_WIDTH) is instance;
    sig_tmod  : in simple_port of uint(bits:2) is instance;
    sig_tadr  : in simple_port of byte is instance;
    sig_stpa  : inout simple_port of bit is instance;
    sig_ptpa  : inout simple_port of bit is instance;
    sig_dtpa  : inout simple_port of uint is instance;
    sig_tclk  : in simple_port of bit is instance;
};
