<'
package shr_spi3;

type shr_spi3_layer_t       : [PHY, LINK];    // Selector for physical or link layer modeling behavior
type shr_spi3_bus_mode_t    : [NARROW, WIDE]; // Narrow mode => 8-bit bus, wide mode => 32-bit bus
type shr_spi3_parity_mode_t : [ODD, EVEN];    // Even or odd parity generation and checking is supported
type shr_spi3_arb_method_t  : [RR, WRR];      // Round-robin or weighted round-robin arbitration is supported
type shr_spi3_direction_t   : [RX, TX];      //Agent SPI3 direction.
type shr_spi3_evc_name_t    : [SPI3];        //evc name
type shr_spi3_payload_kind_t: [RANDOM, LAYERED];   //Payload type - layered pulled form higher layer sequence
type shr_spi3_xSX_cycle_kind_t : [FIXED, RANDOM, DISABLED]; //xSX cycle kind - FIXED = xSX every fixed X cycles
      	             	      	             	      	    //RANDOM = xSX every random X cycles (X gened after every xSX)
							    //DISABLED = never send xSX
type shr_spi3_pkt_status_t : [MOP, SOP, EOP, SINGLE]; 	    //Status of port - Middle, Start, End Of Packet, and SINGLE indicates SOP and EOP in the same cycle;
type shr_spi3_port_direction : [IN, OUT];    	      	    //Direction of port data relative to 'e' code
type shr_spi3_protocol_check_t : [DISABLED, INFO, WARNING, ERROR];   //Level of severity for protocol checks - 
      	             	      	             	      	             //ERROR stops SIM, WARNING and INFO are messages, DISABLED disables check.

define SHR_SPI3_MAX_PORTS      256;           // OIF limits interface definition to 256 ports
define SHR_SPI3_MAX_BUS_WIDTH  32;            // OIF limits maximum data bus width to 32 bits
'>

