<'
//PHY layer DUT config file

extend sys {

   spi3 : shr_spi3_env_u is instance;
   keep spi3.hdl_path() == "~/spi3_tb";
};


extend shr_spi3_env_u {

   keep spi3_agents[0].layer == LINK;
   keep spi3_agents[0].direction == RX;
   keep spi3_agents[0].active_passive == ACTIVE;

   keep spi3_agents[1].layer == LINK;
   keep spi3_agents[1].direction == TX;
   keep spi3_agents[1].active_passive == ACTIVE;

   keep spi3_agents[2].layer == PHY;
   keep spi3_agents[2].direction == RX;
   keep spi3_agents[2].active_passive == ACTIVE;

   keep spi3_agents[3].layer == PHY;
   keep spi3_agents[3].direction == TX;
   keep spi3_agents[3].active_passive == ACTIVE;

};//shr_spi3_env_u

extend shr_spi3_agent_config_u {

   keep numports == 4;
   keep active_ports == {0;1;2;3};

};

extend TX'direction shr_spi3_agent_u {
    keep bind(sig_tsx, external);
    keep sig_tsx.hdl_path() == "TSX";
    keep sig_tsx.verilog_wire() == TRUE;
    
    keep bind(sig_tenb, external);
    keep sig_tenb.hdl_path() == "TENB";
    keep sig_tenb.verilog_wire() == TRUE;
    
    keep bind(sig_tsop, external);
    keep sig_tsop.hdl_path() == "TSOP";
    keep sig_tsop.verilog_wire() == TRUE;
    
    keep bind(sig_teop, external);
    keep sig_teop.hdl_path() == "TEOP";
    keep sig_teop.verilog_wire() == TRUE;
    
    keep bind(sig_terr, external);
    keep sig_terr.hdl_path() == "TERR";
    keep sig_terr.verilog_wire() == TRUE;
    
    keep bind(sig_tprty, external);
    keep sig_tprty.hdl_path() == "TPRTY";
    keep sig_tprty.verilog_wire() == TRUE;
    
    keep bind(sig_tdat, external);
    keep sig_tdat.hdl_path() == "TDAT";    
    keep sig_tdat.verilog_wire() == TRUE;
    keep soft sig_tdat.declared_range() == "[31:0]";

    keep bind(sig_tmod, external);
    keep sig_tmod.hdl_path() == "TMOD";    
    keep sig_tmod.verilog_wire() == TRUE;
    keep soft sig_tmod.declared_range() == "[1:0]";
    
    keep bind(sig_tadr, external);
    keep sig_tadr.hdl_path() == "TADR";
    keep sig_tadr.verilog_wire() == TRUE;
    keep sig_tadr.declared_range() == "[1:0]";
    
    keep bind(sig_stpa, external);
    keep sig_stpa.hdl_path() == "STPA";
    keep sig_stpa.verilog_wire() == TRUE;
    
    keep bind(sig_ptpa, external);
    keep sig_ptpa.hdl_path() == "PTPA";
    keep sig_ptpa.verilog_wire() == TRUE;
    
    keep bind(sig_dtpa, external);
    keep sig_dtpa.hdl_path() == "DTPA_bus";
    keep sig_dtpa.verilog_wire() == TRUE;
    keep sig_dtpa.declared_range() == "[3:0]";
    
    keep bind(sig_tclk, external);
    keep sig_tclk.hdl_path() == "tfclk";
    
    keep bind(sig_tf_rst_l, external);
    keep sig_tf_rst_l.hdl_path() == "tf_rst_l";
    
};

extend RX'direction shr_spi3_agent_u {
    keep bind(sig_rsx, external);
    keep sig_rsx.hdl_path() == "RSX";
    keep sig_rsx.verilog_wire() == TRUE;
    
    keep bind(sig_rval, external);
    keep sig_rval.hdl_path() == "RVAL";
    keep sig_rval.verilog_wire() == TRUE;
    
    keep bind(sig_renb, external);
    keep sig_renb.hdl_path() == "RENB";
    keep sig_renb.verilog_wire() == TRUE;
    
    keep bind(sig_rsop, external);
    keep sig_rsop.hdl_path() == "RSOP";
    keep sig_rsop.verilog_wire() == TRUE;
    
    keep bind(sig_reop, external);
    keep sig_reop.hdl_path() == "REOP";
    keep sig_reop.verilog_wire() == TRUE;
    
    keep bind(sig_rerr, external);
    keep sig_rerr.hdl_path() == "RERR";
    keep sig_rerr.verilog_wire() == TRUE;
    
    keep bind(sig_rprty, external);
    keep sig_rprty.hdl_path() == "RPRTY";
    keep sig_rprty.verilog_wire() == TRUE;
    
    keep bind(sig_rdat, external);
    keep sig_rdat.hdl_path() == "RDAT";
    keep sig_rdat.verilog_wire() == TRUE;
    keep soft sig_rdat.declared_range() == "[31:0]";
    
    keep bind(sig_rmod, external);
    keep sig_rmod.hdl_path() == "RMOD";
    keep sig_rmod.verilog_wire() == TRUE;
    keep soft sig_rmod.declared_range() == "[1:0]";    

    keep bind(sig_rclk, external);
    keep sig_rclk.hdl_path() == "rfclk";
    
    keep bind(sig_rf_rst_l, external);
    keep sig_rf_rst_l.hdl_path() == "rf_rst_l";
    
    
};   

'>
