`timescale 1ns/10ps

module spi3_tb;
   
parameter              ADD_WIDTH = 6;


// srx

reg            rfclk;                   // local clock
reg            rf_rst_l;              //synopsys sync_set_reset "rf_rst_l"

wire            STPA;              // link_layer_mode TX
wire            PTPA;           // link_layer_mode TX
wire            DTPA_0;         // link_layer_mode TX
wire            DTPA_1;         // link_layer_mode TX
wire            DTPA_2;         // link_layer_mode TX
wire            DTPA_3;         // link_layer_mode TX
wire[3:0]  DTPA_bus;		    // all DTPA signals
assign     DTPA_bus={DTPA_3,DTPA_2,DTPA_1,DTPA_0};

reg		tfclk;
reg         	tf_rst_l;       // synopsys sync_set_reset "tf_rst_l"

wire	[1:0]	TADR;         	// link_layer_mode TX 
wire		TENB;    	// link_layer_mode TX 
wire         	TSX;
wire  	[31:0] 	TDAT;  
wire          	TSOP;  
wire          	TPRTY; 
wire          	TERR;  
wire          	TEOP;  
wire   	[1:0]  	TMOD; 


wire		RENB;              // link side flow control
wire            RSX;          // multi-phy address indicator
wire	[31:0] 	RDAT;         // data bus
wire            RSOP;         // start of packet
wire            RPRTY;        // parity of the data bus
wire            RVAL;         // data valid
wire            RERR;         // packet error on eop
wire            REOP;         // end of packet
wire	[1:0] 	RMOD;         // moulo bytes on eop 

initial begin
	rf_rst_l <= 0;
	tf_rst_l <= 0;
	#1000;
	rf_rst_l <= 1;
	tf_rst_l <= 1;
end

initial rfclk = 0;
initial tfclk = 0;

always #1 rfclk <= ~rfclk;
always #1 tfclk <= ~tfclk;

endmodule
